//S - sample matrix. each sample is a column
//a - angle
//retuns values for 
function b = plane_value(S, a)
	//calculate w
	w = [-cos(a); sin(a)];
	w = w / sum(abs(w));

	//calculate the behavior vector
	w(1) = -sqrt(-w(1));
	w(2) = sqrt(w(2));
	R = S'*w;
	R = sign(R);

	for i = 1:size(R,1)
		if R(i) == 0 then
			R(i) = 1;
		end
	end
		
	R1 = -(R - 1) / 2;
	R2 = (R + 1) / 2;
	
	b = 0;
	if sum(R1) > 0 then
		b = b  -w(1)*S(1,:)*R1/sum(R1);
	end
	if sum(R2) > 0 then
		b = b + w(2)*S(2,:)*R2/sum(R2);
	end
endfunction


function B = plane_values(S, A)
	n = size(A,1);
	B = zeros(n,1);

	for i=1:n
		B(i) =  plane_value(S,A(i));
	end
endfunction

//s - number of samples
function S = plot_values(s, x)
	A = [0:0.01:%pi/2]';
	S = rand(2, s);
	S(2,:)=S(2,:).*3
	
	B = plane_values(S,A);
	clf();
	plot2d(A, B, style=[2]);	
	
	if x <> 0 then
		M = atan(S(1,:) ./ S(2,:))';
		M = sort(M);
		N = plane_values(S,M);
		plot2d(M, N, style=[-1]);
	end
endfunction
